﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Syncfusion.XlsIO;

namespace XlsIO_Sample.Controllers
{
    public class XlsIOController : Controller
    {
        public IActionResult Create(string SaveOption)
        {
            if (SaveOption == null)
                return View();

            ExcelEngine excelEngine = new ExcelEngine();
            IApplication application = excelEngine.Excel;
            IWorkbook workbook = application.Workbooks.Create();
            workbook.Version = ExcelVersion.Excel2016;
            IWorksheet sheet1 = workbook.Worksheets[0];

            object[] yValues = new object[] { 2000, 1000, 1000 };
            object[] xValues = new object[] { "Total Income", "Expenses", "Profit" };

            //Adding series and values
            IChartShape chart1 = sheet1.Charts.Add();
            IChartSerie serie1 = chart1.Series.Add(ExcelChartType.Pie);

            //Enters the X and Y values directly
            serie1.EnteredDirectlyValues = yValues;
            serie1.EnteredDirectlyCategoryLabels = xValues;

            chart1.ChartTitle = "Sheet1 Chart";

            var sheet2 = workbook.Worksheets[2];
            IChartShape chart2 = sheet2.Charts.Add();
            IChartSerie serie2 = chart2.Series.Add(ExcelChartType.Bar_Stacked);

            //Enters the X and Y values directly
            serie2.EnteredDirectlyValues = yValues;
            serie2.EnteredDirectlyCategoryLabels = xValues;

            chart2.ChartTitle = "Sheet2 Chart";

            string ContentType = null;
            string fileName = null;

            if (SaveOption == "ExcelXls")
            {
                ContentType = "Application/vnd.ms-excel";
                workbook.Version = ExcelVersion.Excel97to2003;
                fileName = "Sample.xls";
            }
            else
            {
                ContentType = "Application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
                fileName = "Sample.xlsx";
            }

            MemoryStream ms = new MemoryStream();
            workbook.SaveAs(ms);
            ms.Position = 0;

            return File(ms, ContentType, fileName);
        }
    }
}